
int i, j;
int state = 0;
unsigned long int whack_time[8];		// last time a more was whacked
int wakeup[8];							// time to wait untill the mole comes out
int is_lit[8];
int buzz = 0, max_time = 2000;
int game = 0, onoff = 1 ;

// the setup routine runs once when you press reset:
void setup() {      
  
  // initialize leds pins as output.
  for (i=22; i<30; i++) {
    pinMode(i, OUTPUT);
    digitalWrite(i, LOW);
  }
  
  // initialize buttons as input
  for (i=14; i<22; i++) {
    pinMode(i, INPUT);
    digitalWrite(i, HIGH);
  }
  pinMode(onoff, INPUT);
  digitalWrite(onoff, HIGH);
  
  // initialize auxiliary structures
  for (i=0; i<8; i++) {
    is_lit[i] = 0;
    whack_time[i] = 0;
    wakeup[i] = rand()%7000+2000;
  }
  
}

// the loop routine runs over and over again forever:
void loop() {
  
  if (game == 1) {				// if game has started
    for(i=0; i<8; i++) {
      if ((millis() - (whack_time[i]+wakeup[i]) >= max_time) && (is_lit[i] == 1)) {			// if mole was not whacked in due time
        game = 0;
        tone(0, 25);
        for (j=22; j<30; j++) {
          pinMode(j, OUTPUT);
          digitalWrite(j, HIGH);
        }
        delay(100);
        noTone(0);
        
      } else if((millis() - whack_time[i] >= wakeup[i]) && (is_lit[i] == 0)) {				// if assigned time has passes, mole comes out
        digitalWrite(i+22, HIGH);
        is_lit[i] = 1;
      }
    }
    
    for(i=14; i<22; i++) {
      if(digitalRead(i) == LOW) {															// if mole was whacked
        digitalWrite(i+8, LOW);
        is_lit[i-14] = 0;
        whack_time[i-14] = millis();														// reset whack_time
        wakeup[i-14] = rand()%7000+1000;													// set new wakeup time
        tone(0, 25);
        noTone(0);
      }
    }
    
	// if on/off button was pressed, and the game is running, end game
    if(digitalRead(onoff) == LOW) {															 
      game = 0;
        tone(0, 25);
        for (j=22; j<30; j++) {
          pinMode(j, OUTPUT);
          digitalWrite(j, HIGH);
        }
        delay(100);
        noTone(0);
        
    }
    
	// if on/off button is pressed and the game has not started, start game
  } else if(digitalRead(onoff) == LOW) {
      game = 1;
      
      for (i=22; i<30; i++) {
        pinMode(i, OUTPUT);
        digitalWrite(i, LOW);
      }
      
      for (i=0; i<8; i++) {
        is_lit[i] = 0;
        whack_time[i] = millis();
        wakeup[i] = rand()%10000+3000;
      }
     delay(100); 
  }
    
  delay(100);
}
